﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.1
@EndOfDesignText@
' B4Xemail Library written by ThRuST August 10, 2021 for the B4X community.
' Credits to Erel Uziel for original (simple version) email code which is modified for the usage of this library.

' Version 0.4

' Dependecies:
	'jNET
	'jStringUtils

Sub Process_Globals
	
	Public  Email 			As SMTP
	Public  SendTo 			As String = ""
	Private Password 		As String = "password"
	Private Port 			As String = "587"
	Private SMTP 			As String = "SMTP"
	Public  MailType		As String = ""
	Public  su 				As StringUtils
	
End Sub

'
' B4Xemail library by ThRuST.
' Usage: B4Xemail(Subject, Message, Email, TypeOfMail("default" or "html")
' example B4Xemail("Testmail", "Hi <b>B4X</b>", "email@someone.com", "html")
' The mailserver settings have to be predefined as they so far are hardcoded.
' Simply enable the one you prefer. Be aware of this in case you want to convert it into library files.
Public Sub SendMail(Subject As String, Body As String, MailTo As String, TypeOfMail As String)
    	
	' Pick the mailserver you want to use:
	' ------------------------------------
	MailType = TypeOfMail ' use "default" or "html"
	
	' Gmail
	Email.Initialize("smtp.gmail.com", 			Port ,"email@mail.com" , Password, SMTP)
	' One
	'Email.Initialize("send.one.com", 			Port ,"email@mail.com" , Password, SMTP)
	' Yahoo
	'Email.Initialize("SMTP.mail.yahoo.com", 	Port ,"email@mail.com" , Password, SMTP)
	' Office365
	'Email.Initialize("smtp.office365.com", 	Port ,"email@mail.com" , Password, SMTP)
	' Hotmail
	'Email.Initialize("smtp-mail.outlook.com", 	Port ,"email@mail.com" , Password, SMTP)
	
	Email.Subject = Subject
	
	' ###################################################
	' ###   Enable this to send plain text messages   ###
	' ###################################################
	
	If MailType = "default" Then
		Email.HtmlBody = False
		Email.Body = Body
	End If
	' ###################################################
	' ### Enable this to send HTML formatted messages ###
	' ###################################################
	
	If MailType = "html" Then
		
		Email.HtmlBody = True
		Email.Body = su.EncodeBase64(Body.GetBytes("utf8")) 'html = the html body
		Email.AdditionalHeaders.Put("Content-Transfer-Encoding", "BASE64")
	End If
	
	Email.To.Add(MailTo)
	Email.StartTLSMode = True
	Email.Send
		
	Wait For SMTP_MessageSent(Success As Boolean)
	
	Log(Success)
	
	If Success Then
		Log("Email Successfully Sent")
	Else
		Log("Email could not be sent:")
		Log(LastException.Message)
	End If
    
End Sub